using DysonNetwork.Shared.Models;
using MagicOnion;
using NodaTime;

namespace DysonNetwork.Shared.Services;

public interface IAccountEventService : IService<IAccountEventService>
{
    /// <summary>
    /// Purges the status cache for a user
    /// </summary>
    void PurgeStatusCache(Guid userId);
    
    /// <summary>
    /// Gets the status of a user
    /// </summary>
    Task<Status> GetStatus(Guid userId);
    
    /// <summary>
    /// Performs a daily check-in for a user
    /// </summary>
    Task<CheckInResult> CheckInDaily(Account user);
    
    /// <summary>
    /// Gets the check-in streak for a user
    /// </summary>
    Task<int> GetCheckInStreak(Account user);
}
